#include <math.h>
#include <stdio.h>

#include "header.h"

/* Fill Weight[p2] with weights from (t1,p1) -> (t2,p2) 
 * This is stretched out to be readable.  Variables can be 
 * eliminated and loops combined.  Includes the subterfuge.
 */
void weights1(int t1, int p1, int t2){
  int u, p2, points, eu, ig, min,found;
  double f[POINTS], arg[POINTS], growth[UNDERLIERS][POINTS],num_det,den_det;
  static double g[POINTS];
  static int last_t2 = -1;

/*   printf("weights1(%i,%i,%i)\n",t1,p1,t2); */

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  for(u=0;u<UNDERLIERS;++u){ 
    Underlier_mask[u] = 1;
  }
  
  ig = 0;
/*   if(PROBCUTOFF){ */
/*     do{ */
/*       found = 0; */
/*       min = 0; */
/*       for(u=1;u<UNDERLIERS;++u) */
/* 	if(Prob[t1][u][p1] < Prob[t1][min][p1] && Underlier_mask[u] == 1) { */
/* 	  min = u; */
/* 	  found = 1; */
/* 	} */
/*       if(found && Prob[t1][min][p1] < PROBCUTOFF){ */
/* 	Underlier_mask[min] = 0; */
/* 	++ig; */
/*       }else{ */
/* 	found = 0; */
/*       } */
/*     }while(ig < MAXIGNORE && found); */
/*     printf("[%i][%i][%i]\tig = %i\n",t1,p1,t2,ig);  */
/*     Ignore[t1] += (double)ig/(double)points; */
/*   }  */

  if(PROBCUTOFF){
    for(u=0; u<UNDERLIERS; ++u){
      if(Prob[t1][u][p1] < PROBCUTOFF){
	Underlier_mask[u] = 0;
	++ig;
      }
    }
    Ignore[t1] += (double)ig/(double)points_on_timeslice(t1);
/*     printf("[%i][%i][%i]\tig = %i\n",t1,p1,t2,ig); */
  }


  
  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + (t2-t1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += Underlier_mask[u]*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))/((t2-t1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }

  num_det = pow( sqrt((t2-t1)*VARIANCE), UNDERLIERS-ig);

  if(t2 != last_t2){ 
    last_t2 = t2; 
    
    for(p2=0;p2<points;++p2){
      arg[p2] = 0;
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2-0)*VARIANCE/2.0;
      }
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
 	arg[p2] += Underlier_mask[u]*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))/((t2-0)*VARIANCE);
      }
    }
    
    for(p2=0;p2<points;++p2){
      g[p2] = exp(-0.5*arg[p2]);
    }
  }

  den_det = pow( sqrt(t2*VARIANCE), UNDERLIERS-ig);
    
  for(p2=0;p2<points;++p2){
    Weight[p2] = 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
    Sum_weights += 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
  }
}

/* Fill Weight[p2] with weights from (t1,p1) -> (t2,p2) This is
 * stretched out to be readable.  Variables can be eliminated and
 * loops combined.  Does not include the subterfuge, so it can be used
 * to calculate the probabilities needed to implement the subterfuge.
 * */

void weights2(int t1, int p1, int t2){
  int u, p2, points;
  double f[POINTS], arg[POINTS], growth[UNDERLIERS][POINTS],num_det,den_det;
  static double g[POINTS];
  static int last_t2 = -1;

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + (t2-t1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += (growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))/((t2-t1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }

  num_det = pow( sqrt((t2-t1)*VARIANCE), UNDERLIERS);

  if(t2 != last_t2){ 
    last_t2 = t2; 
    
    for(p2=0;p2<points;++p2){
      arg[p2] = 0;
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2-0)*VARIANCE/2.0;
      }
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
 	arg[p2] += (growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))/((t2-0)*VARIANCE);
      }
    }
    
    for(p2=0;p2<points;++p2){
      g[p2] = exp(-0.5*arg[p2]);
    }
  }
    
  den_det = pow( sqrt(t2*VARIANCE), UNDERLIERS);

  for(p2=0;p2<points;++p2){
    Weight[p2] = 1.0/sqrt(num_det)*f[p2]/(1.0/sqrt(den_det)*g[p2]);
    Sum_weights += f[p2]/g[p2];
  }
}
